#-----------------------------------------------------------------------------
%{?!dist:	%define	dist	.ok}
#-----------------------------------------------------------------------------
Name		:	soci
Version		:	4.0.3
Release		:	14.8.0.0%{?dist}
Summary		:	The database access library for C++ programmers

Packager	:	Osukiss Project	<build-ok@osukiss.org>

License		:	Boost Software License
URL		:	https://github.com/SOCI/soci
 

Source0		:	%{name}-%{version}.tar.gz

#-----------------------------------------------------------------------------
BuildRequires	:	boost-devel
BuildRequires	:	cmake
BuildRequires	:	gcc
BuildRequires	:	gcc-c++
BuildRequires	:	mariadb
BuildRequires	:	postgresql
BuildRequires	:	sqlite3
BuildRequires	:	unixODBC-devel
#-----------------------------------------------------------------------------
%description
Originally, SOCI was developed by Maciej Sobczak at CERN
as abstraction layer for Oracle, a Simple Oracle Call Interface.
Later, several database backends have been developed for SOCI,
thus the long name has lost its practicality. Currently,
if you like, SOCI may stand for Simple Open (Database) Call
Interface or something similar.

#-----------------------------------------------------------------------------
%files			
%defattr(-,root,root,-)
%doc AUTHORS ChangeLog NEWS README
%license COPYING
%{_libdir}/lib%{name}_core.so.4.0*
%{_libdir}/lib%{name}_empty.so.4.0*
%{_libdir}/lib%{name}_mysql.so.4.0*
%{_libdir}/lib%{name}_odbc.so.4.0*
%{_libdir}/lib%{name}_postgresql.so.4.0*
%{_libdir}/lib%{name}_sqlite3.so.4.0*

#=============================================================================
%package		devel
Summary		:	Header files, libraries and development documentation for %{name}
	
#-----------------------------------------------------------------------------
Requires	:	%{name}			= %{version}-%{release}
Requires	:	pkg-config

#-----------------------------------------------------------------------------
%description		devel
This package contains the header files, dynamic libraries and
development documentation for %{name}. If you would like to
develop programs using %{name}, you will need to install
%{name}-devel.

#-----------------------------------------------------------------------------
%files			devel
%defattr(-,root,root,-)
%doc AUTHORS ChangeLog NEWS README
%license COPYING
%{_includedir}/%{name}/*.h
%{_includedir}/%{name}/%{name}-config.h.in
%{_includedir}/%{name}/empty/*.h
%exclude %{_includedir}/%{name}/db2/%{name}-db2.h
%exclude %{_includedir}/%{name}/firebird/%{name}-firebird.h
%exclude %{_includedir}/%{name}/oracle/%{name}-oracle.h
%{_libdir}/lib%{name}_core.so
%{_libdir}/lib%{name}_empty.so
%{_libdir}/cmake/SOCI/SOCI*.cmake
 
#=============================================================================
%package		sqlite3-devel
Summary		:	SQLite3 back-end for %{name}
	
#-----------------------------------------------------------------------------
Requires	:	%{name}-devel		= %{version}-%{release}

#-----------------------------------------------------------------------------
%description		sqlite3-devel
This package contains the SQLite3 back-end for %{name}, i.e., header
files and dynamic libraries specific to the SQLite3 database. If you
would like to develop programs using %{name} and SQLite3, you will need
to install %{name}-sqlite3.}

#-----------------------------------------------------------------------------
%files			sqlite3-devel
%defattr(-,root,root,-)
%doc AUTHORS ChangeLog NEWS README
%license COPYING
%{_includedir}/%{name}/sqlite3/*.h
%{_libdir}/lib%{name}_sqlite3.so
 
#=============================================================================
%package		postgresql-devel
Summary		:	SQLite3 back-end for %{name}
	
#-----------------------------------------------------------------------------
Requires	:	%{name}-devel		= %{version}-%{release}

#-----------------------------------------------------------------------------
%description		postgresql-devel
This package contains the Postgresql back-end for %{name}, i.e., header
files and dynamic libraries specific to the SQLite3 database. If you
would like to develop programs using %{name} and Postgresql, you will need
to install %{name}-postgresql.}

#-----------------------------------------------------------------------------
%files			postgresql-devel
%defattr(-,root,root,-)
%doc AUTHORS ChangeLog NEWS README
%license COPYING
%{_includedir}/%{name}/postgresql/*.h
%{_libdir}/lib%{name}_postgresql.so
 
#=============================================================================
%package		odbc-devel
Summary		:	ODBC back-end for %{name}
	
#-----------------------------------------------------------------------------
Requires	:	%{name}-devel		= %{version}-%{release}

#-----------------------------------------------------------------------------
%description		odbc-devel
This package contains the odbc back-end for %{name}, i.e., header
files and dynamic libraries specific to the ODBC database. If you
would like to develop programs using %{name} and odbc, you will need
to install %{name}-odbc.}

#-----------------------------------------------------------------------------
%files			odbc-devel
%defattr(-,root,root,-)
%doc AUTHORS ChangeLog NEWS README
%license COPYING
%{_includedir}/%{name}/odbc/*.h
%{_libdir}/lib%{name}_odbc.so
 
#=============================================================================
%package		mysql-devel
Summary		:	MYSQL back-end for %{name}
	
#-----------------------------------------------------------------------------
Requires	:	%{name}-devel		= %{version}-%{release}

#-----------------------------------------------------------------------------
%description		mysql-devel
This package contains the mysql back-end for %{name}, i.e., header
files and dynamic libraries specific to the MYSQL database. If you
would like to develop programs using %{name} and mysql, you will need
to install %{name}-mysql.}

#-----------------------------------------------------------------------------
%files			mysql-devel
%defattr(-,root,root,-)
%doc AUTHORS ChangeLog NEWS README
%license COPYING
%{_includedir}/%{name}/mysql/*.h
%{_libdir}/lib%{name}_mysql.so
 
#=============================================================================
%prep
%setup -q
mv README.md README
mv CHANGES ChangeLog
mv LICENSE_1_0.txt COPYING
echo "`date +%F`" > NEWS
echo "- Version %{version}" >> NEWS
echo "- See the ChangeLog file for more details." >> NEWS
#-----------------------------------------------------------------------------
#building application
%build

cmake							\
	.						\
	-D CMAKE_INSTALL_PREFIX:PATH=%{_prefix} 	\
	-D CMAKE_INSTALL_LIBDIR:PATH=%{_libdir} 	\
	-D SOCI_STATIC=OFF				\
	-D SOCI_CXX11=ON				\
	-D SOCI_EMPTY=ON				\
	-D SOCI_MYSQL=ON				\
	-D SOCI_ODBC=ON					\
	-D SOCI_POSTGRESQL=ON				\
	-D SOCI_SQLITE3=ON				\
	-D WITH_ORACLE=OFF				\

%define _smp_mflags -j%(/usr/bin/getconf _NPROCESSORS_ONLN)
%{__make} %{_smp_mflags}

#-----------------------------------------------------------------------------
%clean
%{__rm} -rf %{buildroot}

#-----------------------------------------------------------------------------
#installing program
%install
%{__rm} -rf %{buildroot}

%{__make}						\
	DESTDIR=%{buildroot}				\
	install

#-----------------------------------------------------------------------------
%changelog
